#include "Gegenstand.h"


GegenstandTypVar::GegenstandTypVar( GegenstandTyp value )
    : Variable( GEGENSTAND_TYP )
{
    this->value = value;
}

void GegenstandTypVar::setValue( GegenstandTyp value )
{
    this->value = value;
}

GegenstandTyp GegenstandTypVar::getValue() const
{
    return value;
}


Gegenstand::Gegenstand( int id, GegenstandTyp typ, bool onMap = 0, int x = 0, int y = 0, int w = 50, int h = 50 )
    : GameObject( GEGENSTAND, x, y, w, h )
{
    this->id = id;
    this->onMap = onMap;
    this->typ = typ;
}

int Gegenstand::getId() const
{
    return id;
}

GegenstandTyp Gegenstand::getTyp() const
{
    return typ;
}

bool Gegenstand::isOnMap() const
{
    return onMap;
}